class Cactus2 {
  final String axiom = "X";
                             
  final String[][] rules = { {"F", "F", "F", "F", "F", "F"},
                           {"X", "F[+X][-X]","F[+X][-X]", "F[+X]", "F[-X]", "F[+X][+X][-X]"},
                           {"+", "+", "+", "+", "+", "+"},
                           {"-", "-", "-", "-", "-", "-"},
                           {"[", "[", "[", "[", "[", "["},
                           {"]", "]", "]", "]", "]", "]"} };
                             
  String computedWord;
  int iterations;
  float size, angle, scaleFactor;
  
  Cactus2(float size, float angle, float scaleFactor) {
    computedWord = axiom;
    iterations = 0;
    this.size = size;
    this.angle = angle;
    this.scaleFactor = scaleFactor;
  }
  
  float small;
  float med;
  float large;
  float bottom;
  
  void iteration() {
    small = 0.5;
    med = 1;
    large = 2;
    bottom = 7.5;
    char s;
    String newWord = "";
    for(int i = 0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      for(int j=0; j<rules.length; j++) {
        if (s == rules[j][0].charAt(0)) {
          //newWord += rules[j][1];
          newWord += rules[j][(int)random(1,6)];
          break;
        }
      }
    }
    iterations++;
    computedWord = newWord;
    println(iterations +": " + computedWord);
  }
  
  void arc(float size, int deg) {
    for(int i = 0; i<deg; i++) {
      vertex(t.getX(), t.getY());
      t.forward(size);
      t.right(1);
    }
  }

  void arcL(float size, int deg) {
    for(int i = 0; i<deg; i++) {
      vertex(t.getX(), t.getY());
      t.forward(size);
      t.left(1);
    }
  }
  
  void pad(){
    stroke(#53790D);
    fill(#75B205);
    beginShape();
    arc(small,45);
    arc(large,45);
    arc(med,90);
    t.push();
    arc(med,90);
    arc(large,45);
    arc(small,45);
    t.forward(bottom);
    t.pop();
    endShape();
  }
  
  void pricklyPear(){
    stroke(#4713AA);
    fill(#7F13AA);
    beginShape();
    arc(small/4,45);
    arc(large/4,45);
    arc(med/4,90);
    t.push();
    arc(med/4,90);
    arc(large/4,45);
    arc(small/4,45);
    t.forward(bottom/4);
    t.pop();
    endShape();
}
  
  void drawCactus2(Turtle t) {
    char s;
    for(int i=0; i<computedWord.length(); i++) {
      s = computedWord.charAt(i);
      if (s == 'F') {
        small *= scaleFactor;
        med *= scaleFactor;
        large *= scaleFactor;
        bottom *= scaleFactor;
        pad();
      } else if (s == '+') {
        stroke(#53790D);
        arc(med, (int)random(10,angle));
        t.setHeading(t.getHeading() -180);
      } else if (s == '-') {
        stroke(#53790D);
        t.setHeading(t.getHeading() - 180);
        arcL(med, (int)random(10,angle));
      } else if (s == '[') {
        t.push();
      } else if (s == ']') {
        t.pop();
      } else if (s == 'X') {
        t.push();
        pricklyPear();
        t.pop();
      }
    }
  }
}
        
      
