/*****************************************
 * Large Assignment 1: L-Systems
 * Name:    Lauren Urenda
 * E-mail:  lurenda@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    9/15/2022
 *
 * This program draws three different L systems modeling plants
* To model a house plant from my kitchen, uncomment in the draw() function where indicated
* To model a fern, uncomment in the draw() function where indicated
* To model a prickly pear cactus, uncomment in the draw() function where indicated
* To save a photo, press the space button
***********************************************/

import Turtle.*;
Plant p;
Fern f;
Cactus2 c2;
Turtle t;


void setup() {
  size(1500,800);
  background(#830865);
  stroke(#7BB205);
  strokeWeight(2);
  p = new Plant(100, 20, .9);
  f = new Fern(300, 90, 0.333, 0.5);
  c2 = new Cactus2(100, 60, 0.95);
  t = new Turtle(this);
  frameRate(1);
}

void draw() {
  t.setX(width/2);
  t.setY(height-10);
  background(#830865);
  
  //uncomment below to run plant
  //p.drawPlant(t);
  //p.iteration();
  
  //uncomment below to run fern
  //t.setHeading(0);
  //f.drawFern(t);
  //f.iteration();
  
  //uncomment below to run cactus
  t.setHeading(-90);
  c2.drawCactus2(t);
  c2.iteration();
}

//save image when space bar
void keyPressed() {
  if (key == ' ') {
    String filename = "Cactus" + random(0,100) + ".png";
    save(filename);
    println("saved a file: " + filename);
  }
}
